ZOJ 3512 Financial Fraud (左偏树)

题意:给定一个序列,求另一个不递减序列,使得Abs(bi - ai) 和最小。

析:首先是在每个相同的区间中,中位数是最优的,然后由于要合并,和维护中位数,所以我们选用左偏树来维护,当然也可以用划分树来做。

代码如下:

#pragma comment(linker, "/STACK:1024000000,1024000000")
#include <cstdio>
#include <string>
#include <cstdlib>
#include <cmath>
#include <iostream>
#include <cstring>
#include <set>
#include <queue>
#include <algorithm>
#include <vector>
#include <map>
#include <cctype>
#include <cmath>
#include <stack>
#include <sstream>
#define debug() puts("++++");
#define gcd(a, b) __gcd(a, b)
#define lson l,m,rt<<1
#define rson m+1,r,rt<<1|1
#define freopenr freopen("in.txt", "r", stdin)
#define freopenw freopen("out.txt", "w", stdout)
using namespace std;

typedef long long LL;
typedef unsigned long long ULL;
typedef pair<int, int> P;
const int INF = 0x3f3f3f3f;
const double inf = 0x3f3f3f3f3f3f;
const double PI = acos(-1.0);
const double eps = 1e-8;
const int maxn = 50000 + 10;
const int mod = 1e6 + 10;
const int dr[] = {-1, 0, 1, 0};
const int dc[] = {0, 1, 0, -1};
const char *de[] = {"0000", "0001", "0010", "0011", "0100", "0101", "0110", "0111", "1000", "1001", "1010", "1011", "1100", "1101", "1110", "1111"};
int n, m;
const int mon[] = {0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
const int monn[] = {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
inline int Abs(int x){ return x > 0 ? x : -x; }
inline bool is_in(int r, int c){
  return r >= 0 && r < n && c >= 0 && c < m;
}
struct Node{ int key, l, r, d, fa; };
Node tr[maxn];
int iroot(int i){
  if(i == -1)  return -1;
  while(tr[i].fa != -1)  i = tr[i].fa;
  return i;
}

int Merge(int rx, int ry){
  if(rx == -1)  return ry;
  if(ry == -1)  return rx;
  if(tr[rx].key < tr[ry].key)  swap(rx, ry);
  int r = Merge(tr[rx].r, ry);
  tr[rx].r = r;  tr[r].fa = rx;
  if(tr[tr[rx].l].d < tr[r].d)  swap(tr[rx].l, tr[rx].r);
  if(tr[rx].r == -1)  tr[rx].d = 0;
  else  tr[rx].d = tr[tr[rx].r].d + 1;
  return rx;
}

int del(int i){
  if(i == -1) return -1;
  int l = tr[i].l, r = tr[i].r, y = tr[i].fa, x;
  tr[i].l = tr[i].r = tr[i].fa = -1;
  tr[x = Merge(l, r)].fa = y;
  if(y != -1 && tr[y].l == i)  tr[y].l = x;
  else if(y != -1 && tr[y].r == i)  tr[y].r = x;
  for( ; y != -1; x = y, y = tr[y].fa){
    if(tr[tr[y].l].d < tr[tr[y].r].d)  swap(tr[y].l, tr[y].r);
    if(tr[y].d == tr[tr[y].r].d + 1)  break;
    tr[y].d = tr[tr[y].r].d + 1;
  }
  if(x != -1)  return iroot(x);
  return iroot(y);
}

int top(int i){ return tr[i].key; }
int pop(int &i){
  Node out = tr[i];
  int l = tr[i].l, r = tr[i].r;
  tr[i].l = tr[i].r = tr[i].fa = -1;
  tr[l].fa = tr[r].fa = -1;
  i = Merge(l, r);
  return out.key;
}

int a[maxn];
void init(){
  for(int i = 0; i < n; ++i){
    scanf("%d", a+i);
    tr[i].key = a[i];
    tr[i].l = tr[i].r = tr[i].fa = -1;
    tr[i].d = 0;
  }
}
int tree[maxn], sz[maxn], cnt[maxn];

void solve(){
  int m = -1;
  for(int i = 0; i < n; ++i){
    tree[++m] = i;
    sz[m] = cnt[m] = 1;
    while(m > 0 && top(tree[m-1]) >= top(tree[m])){
      tree[m-1] = Merge(tree[m-1], tree[m]);
      sz[m-1] += sz[m];
      cnt[m-1] += cnt[m];
      --m;
      while(cnt[m] > (sz[m]+1) / 2){
        pop(tree[m]);
        --cnt[m];
      }
    }
  }
  LL ans = 0;
  int k = 0;
  for(int i = 0; i <= m; ++i){
    int t = top(tree[i]);
    for(int j = 0; j < sz[i]; ++j, ++k)
      ans += Abs(t - a[k]);
  }
  printf("%lld\n", ans);
}

int main(){
  while(scanf("%d", &n) == 1 && n){
    init();
    solve();
  }
  return 0;
}

  

时间: 2025-01-02 10:04:33

ZOJ 3512 Financial Fraud (左偏树)的相关文章

poj 3666 Making the Grade &amp; zoj 3512 Financial Fraud 左偏树 or dp

//poj 3666 //分析:只是在2005年集训队论文黄源河提到的题目上略微有一点点变化 1 #include"iostream" 2 #include"cstdio" 3 using namespace std; 4 const int maxn = 2100; 5 int v[maxn],l[maxn],r[maxn],d[maxn]; //节点信息 6 int N; 7 int tot,root[maxn],num_now[maxn],num_del[ma

zoj 2334 Monkey King/左偏树+并查集

原题链接:http://acm.zju.edu.cn/onlinejudge/showProblem.do?problemId=1389 大致题意:N只相互不认识的猴子(每只猴子有一个战斗力值) 两只不认识的猴子之间发生冲突,两只猴子会分别请出它们认识的最强壮的 猴子进行决斗.决斗之后这,两群猴子都相互认识了. 决斗的那两只猴子战斗力减半...有m组询问 输入a b表示猴子a和b发生了冲突,若a,b属于同一个集合输出-1 否则输出决斗之后这群猴子(已合并)中最强的战斗力值... 具体思路:用并查

左偏树(Leftist Heap/Tree)简介及代码

左偏树是一种常用的优先队列(堆)结构.与二叉堆相比,左偏树可以高效的实现两个堆的合并操作. 左偏树实现方便,编程复杂度低,而且有着不俗的效率表现. 它的一个常见应用就是与并查集结合使用.利用并查集确定两个元素是否在同一集合,利用左偏树确定某个集合中优先级最高的元素. 1 #include <cstdio> 2 #include <cstring> 3 #include <algorithm> 4 5 template <class T> 6 struct H

关于左偏树的一些东东

大概所有的预备知识这里都有https://baike.baidu.com/item/%E5%B7%A6%E5%81%8F%E6%A0%91/2181887?fr=aladdin 例题1:洛谷 P3377 [模板]左偏树(可并堆) 383通过 1.2K提交 题目提供者HansBug 站长团 标签 难度提高+/省选- 时空限制1s / 128MB 提交 讨论 题解 最新讨论更多讨论 加了路径压缩就WA,路过dal… 左偏树用指针写会MLE吗..… m,n写反了也可以过,数据有… 哪位大神有pbds库

左偏树

概要:左偏树是具有左偏性质的堆有序二叉树,它相比于优先队列,能够实现合并堆的功能. 先仪式型orzorzozr国家集训队论文https://wenku.baidu.com/view/515f76e90975f46527d3e1d5.html 左偏树的节点定义: 1 struct node { 2 int lc, rc, val, dis; 3 } LTree[maxn]; 左偏树的几个基本性质如下: 节点的键值小于等于它的左右子节点的键值 节点的左子节点的距离不小于右子节点的距离 节点的距离等于

学习笔记——左偏树

左偏树是一个堆,为了实现快速合并的操作,我们可以构造一颗二叉树,并且使右子树尽量简短 什么是左偏呢? 定义:一个左偏树的外节点是一个左子树为空或者右子树为空的节点,对于每一个点定义一个距离dist它为到它子树内外节点的最短距离. 一个合法的左偏树节点需要满足堆性以及它的右子树的dist比左子树的dist小. 为什么要这样呢? 这样右子树的dist是严格控制在logn以内的. 于是我们合并的时候,将另一个左偏树与当前左偏树的右子树合并,这样递归下去,则时间复杂度是O(logn)的. 这就是一颗左偏

poj 3016 K-Monotonic 左偏树 + 贪心 + dp

//poj 3016 K-Monotonic//分析:与2005年集训队论文黄源河提到的题目类似,给定序列a,求一序列b,b不减,且sigma(abs(ai-bi))最小.//思路:去除左偏树(大根堆)一半的节点(向上取整),让左偏树的根节点上存放中位数:每个左偏树的根节点表示一个等值区间//在本题中,我们将一段区间 与 一颗左偏树等同:将求调整给定数列 vi 为不减序列的代价 与 求取数列 bi 等同 1 #include"iostream" 2 #include"cstd

BZOJ 1455 罗马游戏 左偏树

题目大意:给定n个点,每个点有一个权值,提供两种操作: 1.将两个点所在集合合并 2.将一个点所在集合的最小的点删除并输出权值 很裸的可并堆 n<=100W 启发式合并不用想了 左偏树就是快啊~ #include<cstdio> #include<cstring> #include<iostream> #include<algorithm> #define M 1001001 using namespace std; struct abcd{ abcd

浅析左偏树的性质及其应用

本文是看了黄源河的论文后才写的 如果本人有哪些地方写得不对的,希望各位大佬改正ORZ 学习C++的大佬应该都会优先队列(原谅我的菜,我连priority_queue都不会拼) 左偏树说到底就是一个升级版的堆 因为左偏树拥有所有堆拥有的功能比如说插入一个节点,取出堆顶和删除堆顶 我们的左偏树的优秀到底体现在哪呢? 左偏树可以合并两个堆!!! 如果我们用普通的做法合并两个堆是需要O(N)的时间 那么如果合并操作非常多 那么堆就不在实用了 先来规定左偏树的一些概念 外节点:一个没有右儿子的节点成为外节